/*
crcplot.h - include file for sunplot, xplot and plotps, and crcplot.a
*/
#ifndef _crcplot_h
#define _crcplot_h

static const char rcsid_crcplot_h[] = 
"$Id: crcplot.h,v 1.3 2000/04/19 18:48:02 ccrawford Exp $";


#include <stdio.h>	/* for plot_fd */

void axis(double x,double y,char *label,int nchar,double len,
	double angle,double fval,double dv);

void clear(void);

void cplot(float *xd,float *yd,float *zd,int nx,int ny,
	double xmin,double xmax,double ymin,double ymax,double xlen,
	double ylen,int pxaxis,int pyaxis,
	float *tv,int nc,int nix,int niy,
	char *tl,char *bl,char *xl,char *yl);

void curve(float *x,float *y,int ne,double delta);

void dline(float *x,float *y,int n,float *dsh,float *gap,int m);

void factor(double x);

void grid(double x,double y,int nx,float *xd,int ny,float *yd);

void hardcopy(void);

void hatch(float *xa,float *ya,int nn,double ang,double pitch);

void line(float *x,float *y,int n,int inc,int type,int sym);

void mouse(float *x,float *y);

void plot_flush(void);

void number(double x,double y,double height,double fpn,double angle,int ndec);

void plot(double x,double y,int i);

void scale(float *array,double axlen,int npts,int inc);

void plotwhere_(float *x,float *y,float *sf);

void plot_warp_(int xp,int yp,float *x,float *y);

void plotfactor_(double x);

void plotinit_(void);

void plot3d(float *x,float *y,float *z,int nx,int ny,
	double xmin,double xmax,double ymin,double ymax,double zmin,double zmax,
	double xlen,double ylen,double zlen,double phi1,double phi2,double resol,
	int pxaxis,int pyaxis,int pzaxis,int xdir,int ydir,
	char *tl,char *bl,char *xl,char *yl,char *zl);

void plot_arc(int x,int y,int x0,int y0,int x1,int y1);

void plot_circle(int x,int y,int r);

void plot_closepl(void);

void plot_cont(int x,int y);

void plot_erase(void);

FILE* plot_fd(void);

void plot_hardcopy(void);

char* plot_host(void);

void plot_label(char *s);

void plot_line(int x1,int y1,int x2,int y2);

void plot_linemod(char *s);

void plot_mouse(int *x,int *y);

void plot_move(int x,int y);

int plot_openpl(void);

void plot_openpl_fd(FILE *fd);

int plot_openpl_host(char *host);

void plot_point(int x,int y);

int plot_port(void);

void plot_space(int x0,int y0,int x1,int y1);

void plot_tops(FILE *ifd,FILE *ofd,int scaleps,int ieps,
	int irot,double ihor,double iver);

void plot_tops_buf(char *buf,int n,FILE *ofd,int scaleps,int ieps,
	int irot,double ihor,double iver);

void plots(void);

void plots_fd(FILE *fd);

void plots_host(char *host);

void plots_close(void);

void plots_open_check(char *s);

int plotss(void);

int plotss_host(char *host);

void symbol(double x,double y,double height,char *itext,double angle,int nc);

void where(float *x,float *y,float *sf);

int monotonicity(float *x,int n);

#endif /* _crcplot_h */
