/*
monotonicity - determine monotonicity of vector
*/

#ident "$Id: monotonicity.c,v 1.3 2007/05/22 15:33:04 ccrawford Exp $"

#include "crcplot.h"

int 
monotonicity(x,n)
float *x;	/* vector */
int n;		/* its length */
{
		/* monotonicity flag 
			-1 = don't know
			0 = constant at beginning
			1 = strictly increasing 
			2 = strictly decreasing 
			3 = increasing 
			4 = decreasing 
			5 = nothing
		*/
	int m;

		/* transition table from current state to new state
		   based on comparison of element w/ previous element.
		   comparison varies fastest. test's < == and > 
		   are 0, 1, 2, respectively. */
	static int states[] = {2,0,1,4,0,3,5,3,1,2,4,5,5,3,3,4,4,5,5,5,5};

	int d; /* result of test, 0, 1, 2 */
	int i; /* index into vector */

	for(m=-1,i=1;i<n;i++){
				/* test element w/ previous element */
		if(x[i] < x[i-1]){
			d = 0;
		}else if(x[i] == x[i-1]){
			d = 1;
		}else{
			d = 2;
		}
				/* get new state, +1 for -1 initial value */
		m = states[(m+1)*3 + d];
	}
	return(m);
}
