/*
number - draw floating point numbers
*/

#ident "$Id: number.c,v 1.3 2007/05/22 15:33:04 ccrawford Exp $"

#include <math.h>
#include "crcplot.h"

void number(x,y,height,fpn,angle,ndec)
double x,y;		/* location of text, 999=use last position */
double height;		/* height of text; <0 use previous height */
double fpn;		/* number to print */
double angle;		/* angle of text in degrees */
int ndec;		/* +ndec: # digits after . w/ rounding 
			   =0 integer + . after rounding
			   =-1 integer, no . after rounding
			   <-1 |ndec|-1 integers truncated */
{
	char c;			/* digit to plot with symbol */
	int inum;		/* numeric version of digit */
	int point;		/* 1=plot decimal point */
	int ni;			/* number of integer digits */
	int nt;			/* number of total digits */
/*
	check for negative number and open plotter
*/
	plots_open_check("number");

	if(fpn < 0.0){
		fpn = -fpn;
		symbol(x,y,height,"-",angle,1);
		x = y = 999.0;
	}
/*
	do rounding and truncating
*/
	if(ndec > 0){
		fpn += 0.5 / pow(10.0,(float)ndec);
		point = 1;
	}else if(ndec == 0){
		fpn += 0.5;
		point = 1;
	}else{
		ndec = -ndec - 1;
		point = 0;
		fpn = ((int)((fpn + 0.5)/(pow(10.,(float)ndec)))) + 0.5;
		ndec = 0;
	}
/*
	normalize to number less than 10
*/
	ni = 1;			
	while(fpn >= 10.0){
		fpn /= 10.0;
		ni++;
	}
/*
	do the plotting
*/
	nt = ni + ndec;

	while(nt--){
		inum = fpn;
		fpn = (fpn - inum) * 10.0;
		c = inum + '0';
		symbol(x,y,height,&c,angle,1);
		x = y = 999.0;
		if(point && nt == ndec) symbol(x,y,height,".",angle,1);
	}
}
	
