/*
basic - "basic" parser interface using global structures

parse_basic - parse argc/argv structure using predefined structures
parse_file_basic - parse initialization file using parse_basic
parse_args_basic - parse enviromental string using parse_basic
parse_help_basic - print help from option/flag structures
parse_all_basic - parse initialization file; envronment and argv; support -@
*/

#ident "$Id: basic.c,v 1.5 2007/05/22 15:51:51 ccrawford Exp $"

#include <string.h>
#include <stdlib.h>
#include "parse.h"

extern struct PARSE_FLAG_TABLE parse_flag_table[];
extern struct PARSE_STRUCT parse_table[];

static char *file_name = NULL;		/* init file */
static char *env_name = NULL;		/* init env var */

void parse_basic(int argc,char **argv)
{
	if(parse_general(parse_table,parse_flag_table,stdout,argc,argv) == -1) 
		exit(1);
}

void parse_file_default(char *file)
{
	if(file == NULL || !strlen(file)) return;
	file_name = parse_malloc_char(strlen(file)+1);
	strcpy(file_name,file);
}

void parse_file_basic(char *file)
{
	parse_file_default(file);

	if(parse_file_proc(parse_table,parse_flag_table,stderr,
	  file,(int (*)())parse_general,1,0,1) == -1) exit(1);
}

void parse_arg_default(char *arg)
{
	if(arg == NULL || !strlen(arg)) return;
	env_name = parse_malloc_char(strlen(arg)+1);
	strcpy(env_name,arg);
}

void parse_args_basic(char *arg)
{
	parse_arg_default(arg);

	if(parse_args_proc(parse_table,parse_flag_table,stderr,
	  arg,(int (*)()) parse_general,1) == -1) exit(1);
}

void 
parse_help_basic (void)
{
	parse_help_general(parse_table,parse_flag_table,stdout);
	if(file_name != NULL)parse_prs("initialization file:",file_name);
	if(env_name != NULL)parse_prs("initialization variable:",env_name);
	exit(1);
}

void parse_all_basic(char *file,char *arg,int argc,char **argv)
{
	int i,init=1;
	char *s;

	for(i=1;i<argc;i++){
		if(argv[i][0] == '-' && (s = strchr(argv[i],'@')) != NULL){
			init = 0;
			*s = ' ';
		}
	}

	if(init && file != NULL){
		if(parse_file_proc(parse_table,parse_flag_table,stderr,
		  file,(int (*)())parse_general,1,1,0) == -1) exit(1);
	}

	if(init && arg != NULL){
		parse_args_basic(arg);
	}
	parse_basic(argc,argv);
}
