/*
parse_malloc - call malloc and check for errors
parse_free - call free and check for errors
parse_malloc_float - alloc floats
parse_malloc_char - alloc chars
parse_malloc_int - alloc ints
parse_malloc_long - alloc longs
parse_malloc_double - alloc double
parse_malloc_short - alloc short ints
*/

#ident "$Id: malloc.c,v 1.4 2007/05/22 15:51:51 ccrawford Exp $"

#include <stdlib.h>
#include "parse.h"

void *parse_malloc(size_t n)
{
	void *c;
	if(NULL == (c = malloc(n))){
		fprintf(stderr,"parse_malloc failure\n");
		exit(1);
	}
	return(c);
}

void 
parse_free (void *p)
{
	free(p);
}

float *
parse_malloc_float (int n)
{
	return((float *)parse_malloc(n*sizeof(float)));
}

char *
parse_malloc_char (int n)
{
	return((char *)parse_malloc(n*sizeof(char)));
}

int *
parse_malloc_int (int n)
{
	return((int *)parse_malloc(n*sizeof(int)));
}

long *
parse_malloc_long (int n)
{
	return((long *)parse_malloc(n*sizeof(long)));
}

double *
parse_malloc_double (int n)
{
	return((double *)parse_malloc(n*sizeof(double)));
}

short *
parse_malloc_short (int n)
{
	return((short *)parse_malloc(n*sizeof(short)));
}
