/*
inputb - input binary files for qplot
*/

#ident "$Id: inputb.c,v 1.7 2007/05/22 15:54:48 ccrawford Exp $"

#include <parse.h>
#include <string.h>
#include "qplot.h"

int 
inputb(char *name,float **vec,int begin,int skip,int count,char ctype)
{
	float ftmp=-1;
	int itype=-1;
	register int    i,ns;
	FILE *fd;
	void *buf=NULL;
	static int sizes[] = {0,sizeof(float),sizeof(int),sizeof(long),
		sizeof(double),sizeof(short)};

	char buf_ii[sizeof(double)];
	buf=(void *)buf_ii;

	switch(ctype){

	case 'r':
	case 'f':
		itype = 1;
		break;
	case 'i':
		itype = 2;
		break;
	case 'l':
		itype = 3;
		break;
	case 'd':
		itype = 4;
		break;
	case 's':
		itype = 5;
		break;
	default:
		parse_uprc(stderr,"*illegal binary file type:",ctype);
	}

	if(itype == 2){
		if(sizeof(int) == sizeof(short)){
			itype = 5;
		}else if(sizeof(int) == sizeof(long)){
			itype = 3;
		}else{
			parse_er("qplot (inputb): unknown size of 'int'");
		}
	}

	if(itype == 4){
		parse_er("qplot (inputb): can't handle double");
	}

	fd = parse_fopen(name,"r");

	i = 0;
	ns = sizes[itype];
	if(begin > 0) (void )fseek(fd,(long)(begin * ns),0);
		
	block_init(1);
	while(fread((char *)buf,ns,1,fd)){
		switch(itype){

		case 1: /* float */
			ftmp = parse_from_can_float(*((long *)buf));
			break;
		case 3: /* long */
			ftmp = parse_from_can_long(*((long *)buf));
			break;
		case 5: /* short */
			ftmp = parse_from_can_short(*((short *)buf));
			break;
		}
		block_add(ftmp,0.0);
		i++;
		if(count > 0 && i >= count)break;
		(void )fseek(fd,(long)((skip)*ns),1);
	}

	parse_fclose(fd);
	if(!i) parse_err("no points read from: ",name);
	if(i != block_flush(vec,(float **)NULL))
		parse_err("internal error: block mismatch","");
	return(i);
}
