/*
anmi - annotate mi-files
*/

static char rcsid[] = "$Id: anmi.c,v 1.6 2004/05/14 22:36:20 ccrawford Exp $";

#include <parse.h>
#include <string.h>

static int print=1;		/* 1=print program status */
static char *ifn="pic.mi";	/* input file name*/
static char *label="anmi";	/* annotation */
static int mode=1;		/* 1=last 0=first 2=arbitrary */
static int n;			/* which image to work on */

struct PARSE_OPTION_TABLE parse_table[] = {
	{"if",PARSE_CHAR,(PARSE_ARG)&ifn,"name of mi-file"},
	{"of",PARSE_CHAR,(PARSE_ARG)&ifn,"name of mi-file"},
	{"label",PARSE_CHAR,(PARSE_ARG)&label,"annotation"},
	{"=",PARSE_CHAR,(PARSE_ARG)&label,"label"},
	{"n",PARSE_INT,(PARSE_ARG)&n,"image number"},
	{"n",PARSE_VALUE(2),(PARSE_ARG)&mode},
	{"?",PARSE_PROC,(PARSE_ARG)parse_help_basic},
	{0,0,0}
};

struct PARSE_FLAG_TABLE parse_flag_table[] = {
	{'p',&print,PARSE_FLAG_CLR,"don't print program information"},
	{'l',&mode,PARSE_FLAG_VALUE(1),"last image"},
	{'f',&mode,PARSE_FLAG_VALUE(0),"first image"},
	{'?',(int *)(parse_help_basic),0,0},
	{0,0,0,0}
};

int
main(argc,argv)
	int argc;
	char **argv;
{
	int nf;
	int blk;
	unsigned short int head[1024];
	FILE *ifd;
	PARSE_MIHEAD *mihead;
/*
	parse command line 
*/
	parse_all_basic(".anmi","ANMI",argc,argv);
/*
	open da file and get header
*/
	ifn = parse_suffix_malloc(ifn,"mi");
	ifd = parse_fopen(ifn,"r+");
	mihead = parse_omi(ifd,0);
	nf = mihead->n;
/*
	parameter manipulation
*/
	if(mode == 0){
		n = 1;
	}else if(mode == 1){
		n = nf;
	}
	parse_pcheck(n,1,nf,"anmi: n range error");
/*
	print program information
*/
	if(print){
		parse_wtext("***************** anmi *****************");
		parse_pdt("---start time");
		parse_rcsid_print(rcsid);
		parse_prs("mi-file:",ifn);
		parse_pri("images =",nf);
		parse_pri("n =",n);
		parse_prs("label:",label);
	}
/*
	do it
*/
	blk = mihead->bptr[n-1];
	parse_rblock(ifd,blk,(char *)head,1);
	strncpy((char *)&head[PARSE_MI_LOC_LABEL],label,PARSE_MI_LEN_LABEL);
	parse_wblock(ifd,blk,(char *)head,1);
/*
	clean and exit
*/
	if(print)parse_pdt("---stop time");
	exit(0);
}
