/*
file - handle the file command
*/

#ident "$Id: file.c,v 1.5 2007/05/22 13:22:45 ccrawford Exp $"

#include "xpic.h"

static void
file_syntax(void)
{
	fputs("Synopsis: load filenames instead of numbers\n",ttyout);
	min_abbreviation();
	fputs("Related: images\n",ttyout);
	fputs("Syntax: file [root:suffix:]files\n",ttyout);
	fputs("file name1...  * same as images with filenames\n",ttyout);
	fputs("root:          * prefix filenames with root\n",ttyout);
	fputs(":suffix:       * append filenames with suffix\n",ttyout);
}

void
cmd_file(void)
{
	int i,sec,row,col,n,prev;
	char *suffix,*root,*sp,*s,*start[MIMAGES],*end[MIMAGES];

	if(argc < 1){
		file_syntax();
		return;
	}

	s = argv[1];

	if((sp = strchr(s,':')) == NULL){
		suffix = root = "";
	}else{
		*sp = 0;
		root = s;
		s = ++sp;
		if((sp = strchr(s,':')) == NULL){
			suffix = "";
		}else{
			*sp = 0;
			suffix = s;
			s = ++sp;
		}
	}

	for(row=col=0,sp=s;*sp;sp++){
		if(*sp == '/')
			row++;
		else if(*sp == '|')
			col++;
	}

	if(row && col){
		fputs("Can't specify columns and rows\n",ttyout);
		return;
	}

	for(sp=s,prev=sec=n=0;;) if(*sp == '=' || *sp == '.' || isalnum(*sp)
	  || *sp == '_' || *sp == '-'){
		start[n] = sp;
		while(*sp == '=' || *sp == '.' || isalnum(*sp) || *sp == '_'
		 || *sp == '-'){
			sp++;
		}
		end[n++] = sp;
		prev = 1;
	}else if(*sp == ',' || *sp == ' '){
		if(prev == 0 || prev == 2){
			start[n++] = NULL;
			if(n > MIMAGES){
				fputs("Too many images\n",ttyout);
				return;
			}
		}
		sp++;
		prev = 2;
	}else if(*sp == '/' || *sp == '|' || !*sp){
		if(prev == 2){
			start[n++] = NULL;
			if(n > MIMAGES){
				fputs("Too many images\n",ttyout);
				return;
			}
		}
		for(i=0;i<n;i++){
			if(start[i] == NULL){
				continue;
			}else{
				if(root) strcpy(ifn,root);
				else *ifn = 0;
				strncat(ifn,start[i],end[i]-start[i]);
				ifn[strlen(root) + end[i]-start[i]] = '\0';
				if(suffix) strcat(ifn,suffix);
				open_file();

				if(file_open){
				  if(!row && !col){
					if(n == 1){
						da_yw = canvas_size_y;
						da_xw = canvas_size_x;
						da_y = 0;
						da_x = 0;
						load16(1,0);
					}else{
						da_yw = canvas_size_y;
						da_xw = canvas_size_x / n;
						da_y = 0;
						da_x = da_xw * i;
						load16(1,0);
					}
				  }else if(row){
					da_yw = canvas_size_y / (row + 1);
					da_xw = canvas_size_x / n;
					da_y = sec * da_yw;
					da_x = da_xw * i;
					load16(1,0);
				  }else if(col){
					da_xw = canvas_size_x / (col + 1);
					da_yw = canvas_size_y / n;
					da_x = sec * da_xw;
					da_y = da_yw * i;
					load16(1,0);
				  }
				}
			}
		}
		sec++;
		if(!*sp++) return;
		prev = n = 0;
	}else{
		fprintf(ttyout,"Illegal character: '%c'\n",*sp);
		return;
	}
}
